package com.huimv.video.dhicc.test.request.screenRequest.sg;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.dahuatech.icc.oauth.model.v202010.GeneralResponse;
import com.huimv.video.dhicc.test.config.OauthConfigBaseInfo;
import com.huimv.video.dhicc.test.config.OauthConfigBaseInfo03;
import com.huimv.video.dhicc.test.constant.Constant;
import com.huimv.video.dhicc.test.request.BaseRequest;
import com.huimv.video.dhicc.test.request.BaseRequest03;
import com.huimv.video.dhicc.test.utils.HttpURLConnectionUtil;
import com.huimv.video.dhicc.test.utils.HttpsURLConnectionUtil;
import com.huimv.video.dhicc.test.utils.UrlUtil;
import lombok.Data;

import java.util.HashMap;
import java.util.Map;

@Data
public class ClientSendMassageXixiaoPersonRequestSg extends BaseRequest<Object> {


    private String alarmStartDateString;

    private String alarmEndDateString;
    private Integer alarmType;
    private Integer dbType;
    private Integer deviceCategory;
    private String[] nodeCodeList;

//    private String method;
//
//    private Map<String,Object> data;


    public ClientSendMassageXixiaoPersonRequestSg() {
    }

    public ClientSendMassageXixiaoPersonRequestSg(OauthConfigBaseInfo oauthConfigBaseInfo) {
        super(oauthConfigBaseInfo, Constant.HTTP_POST, oauthConfigBaseInfo.getHttpConfigInfo().getPrefixUrl() + Constant.MASSAGE_XIXIAO_PERSION, true);
    }

    @Override
    public String  doAction() {
        //重置url信息，替换版本号
        this.setUrl(UrlUtil.dealVersion(this.getUrl()));
        //设置请求参数
        setBody();
        //发送请求
        String res = isEnableHttpTest() ? HttpURLConnectionUtil.doPost(this.getUrl(), this.getBody(), this.getHeader()) : HttpsURLConnectionUtil.doPost(this.getUrl(), this.getBody(), this.getHeader());
        System.out.println(res);
        //获取响应
//        JSONObject jsonObject = JSONObject.parseObject(res);
//        Object data = jsonObject.get("data");
//        GeneralResponse devicePageResponse = JSON.parseObject(res, GeneralResponse.class);
//        System.out.println(data);
        return res;
    }

    private void setBody() {
        //设置请求参数
        Map<String, Object> map = new HashMap<>();
        map.put("alarmStartDateString", this.alarmStartDateString);
        map.put("alarmEndDateString", this.alarmEndDateString);
        map.put("alarmType", this.alarmType);
        map.put("dbType", this.dbType);
        map.put("deviceCategory", this.deviceCategory);
        map.put("nodeCodeList", this.nodeCodeList);
//        map.put("method", this.method);
//        map.put("data", this.data);
        this.setBody(JSON.toJSONString(map));

    }


    public boolean isEnableHttpTest() {
        return super.getOauthConfigBaseInfo().getHttpConfigInfo().isEnableHttpTest();
    }
}
